''*************************************
''*  Altair Simulator Memory v1.2     *
''*  (C) 2007 Michael Rychlik         *
''*************************************

' v1.0 - 01 Oct 2007 - original version
' v1.1 - 09 Dec 2007 - No change just bump verion inline with other modules
' v1.2 - 09 Mar 2008 - No change, just bump version 
 
CON

TPA = $100

  'The following taken from the SIMH Altair simulator cfgccp.lib
  'WARNING !!! Change this is altair_ios also if you change it here !!!

  msize =  20          ' adjust per installed system memory (K bytes)
  bioslen = $d00       ' adjust as bios changes are made (if necessary)
  ccplen = $800        ' cp/m constant
  bdoslen = $e00       ' cp/m constant

  ' cp/m image size (rounded up to next 1k boundary)
  cpmlen = (ccplen + bdoslen + bioslen + $3ff) / $400
  ccpph  = (msize - cpmlen) * 1024         ' ccp start address
  bdosph = ccpph + ccplen                  ' bdos start address
  biosph = ccpph + ccplen + bdoslen        ' bios start address

  bdos   = bdosph + 6                      ' Entry point for BDOS
  
  ' 8080 jmp op code
  jmp_ = %11_000_011
     
VAR     

long length
long idx

VAR


PUB init : Success
{

  'Move our loaded program from where ever it is to the CPM Transient Program Area (TPA)
  length := @prog_file_end - @prog_file
  repeat  idx from 0 to length - 1
    ram_8080.byte[TPA + idx] := prog_file.byte[idx]

  'Move BDOS from where ever it is to the BDOS start address
  repeat  idx from 0 to bdoslen - 1
    ram_8080.byte[bdosph + idx] := bdos_file.byte[idx]

  'Move BDOS from where ever it is to the BDOS start address
  repeat  idx from 0 to bioslen - 1
    ram_8080.byte[biosph + idx] := bios_file.byte[idx]
}





  
PUB get_base : ram_base
  ram_base := @ram_8080


PUB get_size : size
  size := @ram_8080_end - @ram_8080



DAT
'Example 8080 program in a DAT section, this could be loaded from a file
'N.B. This section is shared amoung all the cogs using this object
'Put an 8085 test program in RAM


ram_8080 

        'Under CPM programs are loaded at 100H so fill out low RAM first
         BYTE jmp_                        ' At 0000H Jump (jmp_) to  CBIOSX
'         BYTE 0
'         BYTE $100
         BYTE biosph & $FF
         BYTE (biosph >> 8) & $FF        
         BYTE 0,0
         BYTE jmp_                        ' At 0005H we have a jump in to BDOS
         BYTE bdos & $FF
         BYTE (bdos >> 8) & $FF
         BYTE 0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

         'Load CPM program at 100H
prog_file     file "P.COM"
prog_file_end

ccp_file      file "ccp.com"

         'Load BDOS somewhere...
bdos_file     file "bdos.com"
bdos_file_end
         
         'Load CBIOSX somewhere...
bios_file     file "cbiosx.com"
bios_file_end         

         'Load Altair boot rom...
         'file "altair.com"

ram_8080_end